;; verified (solution exists)

(define (problem p25-net3-b16-g5)
  (:domain pipesworld_strips)
  (:objects
   B10 B14 B4 B6 B15 B13 B8 B2 B11 B5 B0 B1 B7 B9 B12 B3 - batch-atom
   A1 A2 A3 A4 - area
   S12 S13 S34 - pipe
   )

  (:init
   ;; speed of pipe segments
   (= (speed S12) 2)
   (= (speed S13) 2)
   (= (speed S34) 1)
   ;; All pipelines segments are in normal state
   (normal S12)
   (normal S13)
   (normal S34)
   ;; Interfaces restrictions
   (may-interface lco lco)
   (may-interface gasoleo gasoleo)
   (may-interface rat-a rat-a)
   (may-interface oca1 oca1)
   (may-interface oc1b oc1b)
   (may-interface lco gasoleo)
   (may-interface gasoleo lco)
   (may-interface lco oca1)
   (may-interface oca1 lco)
   (may-interface lco oc1b)
   (may-interface oc1b lco)
   (may-interface lco rat-a)
   (may-interface rat-a lco)
   (may-interface gasoleo rat-a)
   (may-interface rat-a gasoleo)
   (may-interface gasoleo oca1)
   (may-interface oca1 gasoleo)
   (may-interface gasoleo oc1b)
   (may-interface oc1b gasoleo)
   (may-interface oca1 oc1b)
   (may-interface oc1b oca1)
   ;; Network topology definition
   (connect A1 A2 S12)
   (connect A1 A3 S13)
   (connect A3 A4 S34)
   ;; Batch-atoms products
   (is-product B10 oc1b)
   (is-product B14 oca1)
   (is-product B4 rat-a)
   (is-product B6 gasoleo)
   (is-product B15 oc1b)
   (is-product B13 oc1b)
   (is-product B8 oc1b)
   (is-product B2 lco)
   (is-product B11 oc1b)
   (is-product B5 oc1b)
   (is-product B0 oc1b)
   (is-product B1 gasoleo)
   (is-product B7 gasoleo)
   (is-product B9 lco)
   (is-product B12 lco)
   (is-product B3 oc1b)
   ;; Batch-atoms initially located in areas
   (on B10 A4)
   (on B4 A2)
   (on B6 A3)
   (on B13 A2)
   (on B8 A1)
   (on B11 A2)
   (on B5 A3)
   (on B0 A4)
   (on B7 A1)
   (on B12 A4)
   (on B3 A4)
   ;; Batch-atoms initially located in pipes
   (first B2 S12)
   (follow B9 B2)
   (last B9 S12)
   (first B15 S13)
   (follow B14 B15)
   (last B14 S13)
   (first B1 S34)
   (last B1 S34)
   ;; Unitary pipeline segments
   (not-unitary S12)
   (not-unitary S13)
   (unitary S34)
   )

  (:goal (and
	  (on B15 A1)
	  (on B2 A2)
	  (on B11 A4)
	  (on B9 A1)
	  (on B3 A2)
	  ))

  (:constraints (and
		 (within 2.1 (on b9 a1))
		 (within 3.1 (on b15 a1))
		 (within 13.1 (on b3 a2))
		 (within 12.1 (on b2 a2))
		 (within 23.2 (on b11 a4))
		 (always-within 2.1 (on b3 a1) (on b5 a1))
		 (always-within 9.6 (on b5 a1) (follow b7 b5))
		 (always-within 1.6 (on b11 a1) (follow b11 b7))
		 (always-within 0.6 (on b11 a1) (follow b8 b11))
		 (always-within 9.6 (on b2 a1) (follow b2 b3))
		 (always-within 5.1 (on b2 a1) (on b14 a1))
		 (always-within 3.1 (on b14 a1) (on b5 a1))
		 (always-within 10.6 (on b14 a1) (follow b13 b14))
		 (always-within 5.1 (on b3 a3) (first b3 s13))
		 (always-within 6.1 (on b3 a3) (on b3 a1))
		 (always-within 2.1 (on b3 a3) (on b0 a3))
		 (always-within 8.1 (on b3 a3) (last b3 s12))
		 (always-within 4.1 (on b1 a3) (on b0 a3))
		 (always-within 2.1 (on b14 a3) (first b14 s13))
		 (always-within 2.6 (on b14 a3) (follow b14 b2))
		 (always-within 0.6 (on b14 a3) (follow b14 b15))
		 (always-within 15.7 (on b14 a3) (first b14 s12))
		 (always-within 5.1 (on b14 a3) (on b0 a3))
		 (always-within 18.2 (on b14 a3) (on b11 a3))
		 (always-within 17.2 (on b14 a3) (on b8 a3))
		 ))

  )
